> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Create a workbook from a code representation (Beta)

POST https://api.sigmacomputing.com/v2/workbooks/spec
Content-Type: application/json

This endpoint creates a new workbook from a code representation. Use it to programmatically define and create workbooks that are then accessible from the Sigma UI.

**Beta**: This documentation describes a private beta feature and is subject to the [Beta features](/docs/sigma-product-releases#beta-features) disclaimer.

For more information on managing workbooks programmatically, see [Manage workbooks as code](https://help.sigmacomputing.com/docs/manage-workbooks-as-code). For more information on using this endpoint, including end-to-end instructions, see [Create a workbook from a code representation](https://help.sigmacomputing.com/docs/create-a-workbook-from-a-code-representation).

### System and user requirements
- To perform this operation, you must use API credentials owned by a user assigned an account type with **Create, edit, and publish workbooks** permission.
- To perform this operation, you must use API credentials owned by a user with **Can edit** access for the workbook.

### Usage notes
- You can define the layout of contents on the workbook page using XML in the `layout` field. For more information, see [Customize the layout of a workbook in code representation](https://help.sigmacomputing.com/docs/customize-the-layout-of-a-workbook-in-code-representation).
- You can combine multiple YAML documents to create one workbook representation. For more information, see [Prepare a representation from multiple YAML documents](https://help.sigmacomputing.com/docs/create-a-workbook-from-a-code-representation#prepare-a-representation-from-multiple-yaml-documents).
- To retrieve the representation of an existing workbook, use the [/v2/workbooks/{workbookId}/spec](https://help.sigmacomputing.com/reference/get-workbook-spec) endpoint.
- To update an existing workbook from code, use the [/v2/workbooks/{workbookId}/spec](https://help.sigmacomputing.com/reference/update-workbook-spec) endpoint.
- To get a list of folders, call the [/v2/files](https://help.sigmacomputing.com/reference/list-files) endpoint and review the `id` field in the response for files with a `type` of `folder`.

### Usage scenarios
- **Agentic workflows**: Agents can use these endpoints to directly manage workbook contents in code.
- **Automation**: If you want to create several workbooks across one or more organizations, you can use this endpoint to programmatically create the workbooks.
- **Integration**: Using this endpoint, you can create workbooks based on external data sources or integrate Sigma with other tools and platforms.
- **Migration**: You can use this endpoint to migrate workbooks from one organization to another.


Reference: https://help.sigmacomputing.com/reference/create-workbook-spec

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: code-representation
  version: 1.0.0
paths:
  /v2/workbooks/spec:
    post:
      operationId: createWorkbookSpec
      summary: Create a workbook from a code representation (Beta)
      description: >
        This endpoint creates a new workbook from a code representation. Use it
        to programmatically define and create workbooks that are then accessible
        from the Sigma UI.


        **Beta**: This documentation describes a private beta feature and is
        subject to the [Beta
        features](/docs/sigma-product-releases#beta-features) disclaimer.


        For more information on managing workbooks programmatically, see [Manage
        workbooks as
        code](https://help.sigmacomputing.com/docs/manage-workbooks-as-code).
        For more information on using this endpoint, including end-to-end
        instructions, see [Create a workbook from a code
        representation](https://help.sigmacomputing.com/docs/create-a-workbook-from-a-code-representation).


        ### System and user requirements

        - To perform this operation, you must use API credentials owned by a
        user assigned an account type with **Create, edit, and publish
        workbooks** permission.

        - To perform this operation, you must use API credentials owned by a
        user with **Can edit** access for the workbook.


        ### Usage notes

        - You can define the layout of contents on the workbook page using XML
        in the `layout` field. For more information, see [Customize the layout
        of a workbook in code
        representation](https://help.sigmacomputing.com/docs/customize-the-layout-of-a-workbook-in-code-representation).

        - You can combine multiple YAML documents to create one workbook
        representation. For more information, see [Prepare a representation from
        multiple YAML
        documents](https://help.sigmacomputing.com/docs/create-a-workbook-from-a-code-representation#prepare-a-representation-from-multiple-yaml-documents).

        - To retrieve the representation of an existing workbook, use the
        [/v2/workbooks/{workbookId}/spec](https://help.sigmacomputing.com/reference/get-workbook-spec)
        endpoint.

        - To update an existing workbook from code, use the
        [/v2/workbooks/{workbookId}/spec](https://help.sigmacomputing.com/reference/update-workbook-spec)
        endpoint.

        - To get a list of folders, call the
        [/v2/files](https://help.sigmacomputing.com/reference/list-files)
        endpoint and review the `id` field in the response for files with a
        `type` of `folder`.


        ### Usage scenarios

        - **Agentic workflows**: Agents can use these endpoints to directly
        manage workbook contents in code.

        - **Automation**: If you want to create several workbooks across one or
        more organizations, you can use this endpoint to programmatically create
        the workbooks.

        - **Integration**: Using this endpoint, you can create workbooks based
        on external data sources or integrate Sigma with other tools and
        platforms.

        - **Migration**: You can use this endpoint to migrate workbooks from one
        organization to another.
      tags:
        - workbooks
      parameters:
        - name: Authorization
          in: header
          description: Bearer authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/workbooks_createWorkbookSpec_Response_200'
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateWorkbookSpec'
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    CreateWorkbookSpecSchemaVersion:
      type: string
      enum:
        - '1'
      description: The schema version used by this representation of the workbook.
      title: CreateWorkbookSpecSchemaVersion
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Kind:
      type: string
      enum:
        - table
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormatOneOf0Kind:
      type: string
      enum:
        - number
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormatOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat0:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormatOneOf0Kind
        formatString:
          type: string
          description: The format of the number specified in d3 format.
        prefix:
          type: string
          description: The prefix to apply to the number.
        suffix:
          type: string
          description: The suffix to apply to the number.
        displayNullAs:
          type: string
          description: The display value to show for null values.
        decimalSymbol:
          type: string
          description: The character used for decimal notation.
        digitGroupingSymbol:
          type: string
          description: The character used to separate digits in large numbers.
        digitGroupingSize:
          type: array
          items:
            type: number
            format: double
          description: The interval at which to use the digit grouping symbol.
        currencySymbol:
          type: string
          description: The characters used for currency.
      required:
        - kind
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormatOneOf1Kind:
      type: string
      enum:
        - datetime
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormatOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormatOneOf1Kind
        formatString:
          type: string
          description: The format of the date specified in d3 time format.
      required:
        - kind
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat1
      description: The display format of the column.
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape0:
      type: string
      enum:
        - line
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape1:
      type: string
      enum:
        - bar
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape1
      description: 'Sparkline geometry: ''line'' or ''bar''. Omit when auto.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColorOneOf1Kind:
      type: string
      enum:
        - theme
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColorOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColor1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColorOneOf1Kind
        ref:
          type: string
      required:
        - kind
        - ref
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColor1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColor:
      oneOf:
        - type: string
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColor1
      description: >-
        Hex color (`#rgb` or `#rrggbb`) or theme color reference `{ kind:
        "theme", ref: "colors-xxx" }`.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColor
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation0:
      type: string
      enum:
        - linear
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation1:
      type: string
      enum:
        - monotone
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation2:
      type: string
      enum:
        - step
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation3:
      type: string
      enum:
        - step-before
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation4:
      type: string
      enum:
        - step-after
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation4
      description: 'Line interpolation: linear, monotone, step, step-before, or step-after.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing0:
      type: string
      enum:
        - zero
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing1:
      type: string
      enum:
        - interpolate
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing2:
      type: string
      enum:
        - hide
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing2
      description: How null values are drawn between points.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle0:
      type: string
      enum:
        - solid
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle1:
      type: string
      enum:
        - dashed
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle2:
      type: string
      enum:
        - dotted
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle2
      description: 'Stroke pattern: ''solid'', ''dashed'', or ''dotted''.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth0:
      type: string
      enum:
        - '1'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth1:
      type: string
      enum:
        - '2'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth2:
      type: string
      enum:
        - '3'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth3:
      type: string
      enum:
        - '4'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth4:
      type: string
      enum:
        - '5'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth4
      description: Stroke width in pixels (1–5).
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLine:
      type: object
      properties:
        style:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineStyle
          description: 'Stroke pattern: ''solid'', ''dashed'', or ''dotted''.'
        width:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLineWidth
          description: Stroke width in pixels (1–5).
      description: Line stroke for line-shaped sparklines.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLine
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip0:
      type: string
      enum:
        - shown
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip1:
      type: string
      enum:
        - hidden
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip1
      description: Whether the sparkline cell shows a hover tooltip.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf0Visibility:
      type: string
      enum:
        - hidden
      description: Point markers hidden. Must not include `shape` or `size`.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf0Visibility
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints0:
      type: object
      properties:
        visibility:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf0Visibility
          description: Point markers hidden. Must not include `shape` or `size`.
      required:
        - visibility
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Visibility:
      type: string
      enum:
        - shown
      description: >-
        Point markers shown. Omit on read when shown; may be set explicitly on
        write.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Visibility
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape0:
      type: string
      enum:
        - circle
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape1:
      type: string
      enum:
        - square
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape2:
      type: string
      enum:
        - cross
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape3:
      type: string
      enum:
        - diamond
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape4:
      type: string
      enum:
        - triangle-up
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape4
      description: Point marker shape.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size0:
      type: string
      enum:
        - '4'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size1:
      type: string
      enum:
        - '9'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size2:
      type: string
      enum:
        - '16'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size3:
      type: string
      enum:
        - '25'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size4:
      type: string
      enum:
        - '36'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size5:
      type: string
      enum:
        - '64'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size5
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size6:
      type: string
      enum:
        - '100'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size6
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size7:
      type: string
      enum:
        - '144'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size7
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size8:
      type: string
      enum:
        - '225'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size8
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size4
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size5
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size6
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size7
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size8
      description: >-
        Point size by area scale (radius squared), when no size channel is
        bound.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints1:
      type: object
      properties:
        visibility:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Visibility
          description: >-
            Point markers shown. Omit on read when shown; may be set explicitly
            on write.
        shape:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Shape
          description: Point marker shape.
        size:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePointsOneOf1Size
          description: >-
            Point size by area scale (radius squared), when no size channel is
            bound.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints1
      description: Point markers on line sparklines.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf0Visibility:
      type: string
      enum:
        - hidden
      description: Endpoint labels hidden. Must not include `color` or `fontSize`.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf0Visibility
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels0:
      type: object
      properties:
        visibility:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf0Visibility
          description: Endpoint labels hidden. Must not include `color` or `fontSize`.
      required:
        - visibility
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Visibility:
      type: string
      enum:
        - shown
      description: >-
        Endpoint labels shown. Omit on read when shown; may be set explicitly on
        write.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Visibility
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1ColorOneOf1Kind:
      type: string
      enum:
        - theme
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1ColorOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Color1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1ColorOneOf1Kind
        ref:
          type: string
      required:
        - kind
        - ref
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Color1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Color:
      oneOf:
        - type: string
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Color1
      description: >-
        Hex color (`#rgb` or `#rrggbb`) or theme color reference `{ kind:
        "theme", ref: "colors-xxx" }`.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Color
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels1:
      type: object
      properties:
        visibility:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Visibility
          description: >-
            Endpoint labels shown. Omit on read when shown; may be set
            explicitly on write.
        color:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabelsOneOf1Color
          description: >-
            Hex color (`#rgb` or `#rrggbb`) or theme color reference `{ kind:
            "theme", ref: "colors-xxx" }`.
        fontSize:
          type: number
          format: double
          description: Label font size in pixels.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels1
      description: Endpoint value labels on line sparklines.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparkline:
      type: object
      properties:
        shape:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineShape
          description: 'Sparkline geometry: ''line'' or ''bar''. Omit when auto.'
        color:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineColor
          description: >-
            Hex color (`#rgb` or `#rrggbb`) or theme color reference `{ kind:
            "theme", ref: "colors-xxx" }`.
        interpolation:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineInterpolation
          description: >-
            Line interpolation: linear, monotone, step, step-before, or
            step-after.
        missing:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineMissing
          description: How null values are drawn between points.
        line:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLine
          description: Line stroke for line-shaped sparklines.
        tooltip:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineTooltip
          description: Whether the sparkline cell shows a hover tooltip.
        points:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklinePoints
          description: Point markers on line sparklines.
        labels:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparklineLabels
          description: Endpoint value labels on line sparklines.
      description: Sparkline mark formatting for sparkline-type columns.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparkline
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign0:
      type: string
      enum:
        - left
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign1:
      type: string
      enum:
        - center
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign2:
      type: string
      enum:
        - right
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign2
      description: 'Horizontal alignment of cell content: left, center, or right.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign0:
      type: string
      enum:
        - start
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign1:
      type: string
      enum:
        - middle
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign2:
      type: string
      enum:
        - end
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign2
      description: 'Vertical alignment of cell content: start, middle, or end.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColorOneOf0Kind:
      type: string
      enum:
        - theme
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColorOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColor0:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColorOneOf0Kind
        ref:
          type: string
      required:
        - kind
        - ref
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColor0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColor:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColor0
        - type: string
      description: 'Cell background: `{ kind: theme, ref }` or hex `#rgb` / `#rrggbb` only.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColor
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColorOneOf0Kind:
      type: string
      enum:
        - theme
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColorOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColor0:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColorOneOf0Kind
        ref:
          type: string
      required:
        - kind
        - ref
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColor0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColor:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColor0
        - type: string
      description: 'Cell text color: `{ kind: theme, ref }` or hex only.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColor
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap0:
      type: string
      enum:
        - wrap
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap1:
      type: string
      enum:
        - clip
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap1
      description: 'Text overflow: ''wrap'' or ''clip'' (no wrap).'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyle:
      type: object
      properties:
        align:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleAlign
          description: 'Horizontal alignment of cell content: left, center, or right.'
        verticalAlign:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleVerticalAlign
          description: 'Vertical alignment of cell content: start, middle, or end.'
        width:
          type: number
          format: double
          description: Column width in pixels when overriding auto-sizing.
        backgroundColor:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleBackgroundColor
          description: >-
            Cell background: `{ kind: theme, ref }` or hex `#rgb` / `#rrggbb`
            only.
        color:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleColor
          description: 'Cell text color: `{ kind: theme, ref }` or hex only.'
        textWrap:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyleTextWrap
          description: 'Text overflow: ''wrap'' or ''clip'' (no wrap).'
      description: Grid presentation for this column (alignment, width, colors, wrap).
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyle
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLinkOneOf0Kind:
      type: string
      enum:
        - column
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLinkOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink0:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLinkOneOf0Kind
        columnId:
          type: string
          description: >-
            External id of a column in this table whose text values are the
            hyperlink URL.
      required:
        - kind
        - columnId
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLinkOneOf1Kind:
      type: string
      enum:
        - formula
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLinkOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLinkOneOf1Kind
        formula:
          type: string
          description: Text-typed formula for the hyperlink URL.
      required:
        - kind
        - formula
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink1
      description: >-
        Hyperlink target for this column: another column’s text values or a
        custom URL formula.
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItems:
      type: object
      properties:
        id:
          type: string
          description: The identifier of the column.
        formula:
          type: string
          description: The reference or calculation for the column.
        name:
          type: string
          description: The display name of the column.
        description:
          type: string
          description: The description of the column.
        hidden:
          type: boolean
          description: Indicates whether or not the column is hidden from view.
        format:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsFormat
          description: The display format of the column.
        sparkline:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsSparkline
          description: Sparkline mark formatting for sparkline-type columns.
        style:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsStyle
          description: Grid presentation for this column (alignment, width, colors, wrap).
        link:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItemsLink
          description: >-
            Hyperlink target for this column: another column’s text values or a
            custom URL formula.
      required:
        - id
        - formula
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0ColumnsItems
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf0Kind:
      type: string
      enum:
        - warehouse-table
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source0:
      type: object
      properties:
        connectionId:
          type: string
          description: The identifier of the connection to the data platform.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf0Kind
        path:
          type: array
          items:
            type: string
          description: The path of the table in the data platform.
      required:
        - connectionId
        - kind
        - path
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf1Kind:
      type: string
      enum:
        - sql
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source1:
      type: object
      properties:
        connectionId:
          type: string
          description: The identifier of the connection to the data platform.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf1Kind
        statement:
          type: string
          description: The custom SQL statement used in the element.
      required:
        - connectionId
        - kind
        - statement
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf2Kind:
      type: string
      enum:
        - table
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf2Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source2:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf2Kind
        elementId:
          type: string
          description: The identifier of the table in this data model.
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - kind
        - elementId
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf3Kind:
      type: string
      enum:
        - data-model
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf3Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source3:
      type: object
      properties:
        dataModelId:
          type: string
          description: The identifier of the data model source.
        elementId:
          type: string
          description: The identifier of the table in the referenced data model.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf3Kind
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - dataModelId
        - elementId
        - kind
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4Kind:
      type: string
      enum:
        - join
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf0Kind:
      type: string
      enum:
        - warehouse-table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft0:
      type: object
      properties:
        connectionId:
          type: string
          description: The identifier of the connection to the data platform.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf0Kind
        path:
          type: array
          items:
            type: string
          description: The path of the table in the data platform.
      required:
        - connectionId
        - kind
        - path
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf1Kind:
      type: string
      enum:
        - table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf1Kind
        elementId:
          type: string
          description: The identifier of the table in this data model.
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - kind
        - elementId
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf2Kind:
      type: string
      enum:
        - data-model
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf2Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft2:
      type: object
      properties:
        dataModelId:
          type: string
          description: The identifier of the data model source.
        elementId:
          type: string
          description: The identifier of the table in the referenced data model.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeftOneOf2Kind
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - dataModelId
        - elementId
        - kind
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft2
      description: The name of the left table in the join.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf0Kind:
      type: string
      enum:
        - warehouse-table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight0:
      type: object
      properties:
        connectionId:
          type: string
          description: The identifier of the connection to the data platform.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf0Kind
        path:
          type: array
          items:
            type: string
          description: The path of the table in the data platform.
      required:
        - connectionId
        - kind
        - path
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf1Kind:
      type: string
      enum:
        - table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf1Kind
        elementId:
          type: string
          description: The identifier of the table in this data model.
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - kind
        - elementId
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf2Kind:
      type: string
      enum:
        - data-model
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf2Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight2:
      type: object
      properties:
        dataModelId:
          type: string
          description: The identifier of the data model source.
        elementId:
          type: string
          description: The identifier of the table in the referenced data model.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRightOneOf2Kind
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - dataModelId
        - elementId
        - kind
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight2
      description: The name of the right table in the join.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp0:
      type: string
      enum:
        - <
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp1:
      type: string
      enum:
        - <=
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp2:
      type: string
      enum:
        - '='
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp3:
      type: string
      enum:
        - '!='
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp4:
      type: string
      enum:
        - '>='
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp5:
      type: string
      enum:
        - '>'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp5
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp6:
      type: string
      enum:
        - within
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp6
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp7:
      type: string
      enum:
        - intersects
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp7
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp8:
      type: string
      enum:
        - is-distinct-from
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp8
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp9:
      type: string
      enum:
        - is-not-distinct-from
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp9
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp4
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp5
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp6
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp7
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp8
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp9
      description: >-
        The comparison operator used in the join. Defaults to =. within and
        intersects are only supported with the Geography data type.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItems:
      type: object
      properties:
        left:
          type: string
          description: >-
            The column reference or formula expression from the left source used
            in the join. E.g. ”[ID]” or ”DateTrunc(`year`, [Date])”.
        right:
          type: string
          description: >-
            The column reference or formula expression from the right source
            used in the join.  E.g. ”[ID]” or ”DateTrunc(`year`, [Date])”.
        op:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItemsOp
          description: >-
            The comparison operator used in the join. Defaults to =. within and
            intersects are only supported with the Geography data type.
      required:
        - left
        - right
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItems
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType0:
      type: string
      enum:
        - inner
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType1:
      type: string
      enum:
        - left-outer
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType2:
      type: string
      enum:
        - right-outer
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType3:
      type: string
      enum:
        - full-outer
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType4:
      type: string
      enum:
        - lookup
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType4
      description: The logical join type.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItems:
      type: object
      properties:
        left:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsLeft
          description: The name of the left table in the join.
        right:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsRight
          description: The name of the right table in the join.
        columns:
          type: array
          items:
            $ref: >-
              #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsColumnsItems
          description: A list of the column pairs and operators that define this join.
        name:
          type: string
          description: The name of the join. Defaults to the name of the right.
        joinType:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItemsJoinType
          description: The logical join type.
      required:
        - left
        - right
        - columns
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItems
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf0Kind:
      type: string
      enum:
        - warehouse-table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource0:
      type: object
      properties:
        connectionId:
          type: string
          description: The identifier of the connection to the data platform.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf0Kind
        path:
          type: array
          items:
            type: string
          description: The path of the table in the data platform.
      required:
        - connectionId
        - kind
        - path
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf1Kind:
      type: string
      enum:
        - table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf1Kind
        elementId:
          type: string
          description: The identifier of the table in this data model.
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - kind
        - elementId
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf2Kind:
      type: string
      enum:
        - data-model
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf2Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource2:
      type: object
      properties:
        dataModelId:
          type: string
          description: The identifier of the data model source.
        elementId:
          type: string
          description: The identifier of the table in the referenced data model.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySourceOneOf2Kind
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - dataModelId
        - elementId
        - kind
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource2
      description: >-
        The primary/head source of the join. If not specified, it is inferred as
        the unique source that appears on the left of some join but never on the
        right.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source4:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4Kind
        joins:
          type: array
          items:
            $ref: >-
              #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4JoinsItems
          description: >-
            A list of the joins and their definitions. The left of each join
            must be either the primary source or the right of some other join.
        name:
          type: string
          description: The name of the join. Defaults to the name of the primary source.
        primarySource:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf4PrimarySource
          description: >-
            The primary/head source of the join. If not specified, it is
            inferred as the unique source that appears on the left of some join
            but never on the right.
      required:
        - kind
        - joins
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5Kind:
      type: string
      enum:
        - union
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf0Kind:
      type: string
      enum:
        - warehouse-table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems0:
      type: object
      properties:
        connectionId:
          type: string
          description: The identifier of the connection to the data platform.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf0Kind
        path:
          type: array
          items:
            type: string
          description: The path of the table in the data platform.
      required:
        - connectionId
        - kind
        - path
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf1Kind:
      type: string
      enum:
        - table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf1Kind
        elementId:
          type: string
          description: The identifier of the table in this data model.
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - kind
        - elementId
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf2Kind:
      type: string
      enum:
        - data-model
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf2Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems2:
      type: object
      properties:
        dataModelId:
          type: string
          description: The identifier of the data model source.
        elementId:
          type: string
          description: The identifier of the table in the referenced data model.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItemsOneOf2Kind
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - dataModelId
        - elementId
        - kind
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems2
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5MatchesItems:
      type: object
      properties:
        outputColumnName:
          type: string
          description: The name of the union output column.
        sourceColumns:
          type: array
          items:
            type:
              - string
              - 'null'
          description: >-
            The matching set of source columns that correspond to the union
            output column.
      required:
        - outputColumnName
        - sourceColumns
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5MatchesItems
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source5:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5Kind
        sources:
          type: array
          items:
            $ref: >-
              #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5SourcesItems
          description: The identifiers of the sources in the union.
        matches:
          type: array
          items:
            $ref: >-
              #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf5MatchesItems
          description: >-
            The union output columns and the matched source columns that
            comprise them.
      required:
        - kind
        - sources
        - matches
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source5
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Kind:
      type: string
      enum:
        - transpose
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf0Kind:
      type: string
      enum:
        - warehouse-table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf0Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source0:
      type: object
      properties:
        connectionId:
          type: string
          description: The identifier of the connection to the data platform.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf0Kind
        path:
          type: array
          items:
            type: string
          description: The path of the table in the data platform.
      required:
        - connectionId
        - kind
        - path
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf1Kind:
      type: string
      enum:
        - table
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf1Kind
        elementId:
          type: string
          description: The identifier of the table in this data model.
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - kind
        - elementId
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf2Kind:
      type: string
      enum:
        - data-model
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf2Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source2:
      type: object
      properties:
        dataModelId:
          type: string
          description: The identifier of the data model source.
        elementId:
          type: string
          description: The identifier of the table in the referenced data model.
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6SourceOneOf2Kind
        groupingId:
          type: string
          description: The identifier of the grouping to apply to the table.
      required:
        - dataModelId
        - elementId
        - kind
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source2
      description: The identifier of the source in the transpose.
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Direction:
      type: string
      enum:
        - row-to-column
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Direction
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate0:
      type: string
      enum:
        - min
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate1:
      type: string
      enum:
        - max
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate2:
      type: string
      enum:
        - count
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate3:
      type: string
      enum:
        - count-if
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate3
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate4:
      type: string
      enum:
        - count-distinct
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate4
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate5:
      type: string
      enum:
        - sum
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate5
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate6:
      type: string
      enum:
        - avg
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate6
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate7:
      type: string
      enum:
        - median
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate7
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate4
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate5
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate6
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate7
      description: Indicates the calculation performed on the valueColumn.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source6:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Kind
        source:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Source
          description: The identifier of the source in the transpose.
        direction:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Direction
        outputColumns:
          type: array
          items:
            type: string
          description: The list of columns in the transposed table.
        columnToTranspose:
          type: string
          description: >-
            The identifier of the column whose values are used as column
            headings.
        valueColumn:
          type: string
          description: >-
            The identifier of the column used to calculate cell values for each
            row in the transposed columns.
        aggregate:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0SourceOneOf6Aggregate
          description: Indicates the calculation performed on the valueColumn.
        columnsToMerge:
          type: array
          items:
            type: string
          description: >-
            The list of columns to merge in the transposed table. Must be of the
            same data type.
        columnLabelForMergedColumns:
          type: string
          description: The display name of the merged column in the transposed table.
        columnLabelForValues:
          type: string
          description: The display name of the column of transposed values.
      required:
        - kind
        - source
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source6
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source2
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source3
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source4
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source5
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source6
      description: The source of the table.
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Source
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf1Visibility:
      type: string
      enum:
        - hidden
      description: >-
        Set to 'hidden' to explicitly hide the title (overrides the
        default-shown behavior).
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf1Visibility
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name1:
      type: object
      properties:
        visibility:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf1Visibility
          description: >-
            Set to 'hidden' to explicitly hide the title (overrides the
            default-shown behavior).
      required:
        - visibility
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2ColorOneOf1Kind:
      type: string
      enum:
        - theme
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2ColorOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Color1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2ColorOneOf1Kind
        ref:
          type: string
      required:
        - kind
        - ref
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Color1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Color:
      oneOf:
        - type: string
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Color1
      description: >-
        Hex color (`#rgb` or `#rrggbb`) or theme color reference `{ kind:
        "theme", ref: "colors-xxx" }`.
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Color
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight0:
      type: string
      enum:
        - normal
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight1:
      type: string
      enum:
        - bold
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight1
      description: 'Title font weight: ''normal'' or ''bold''.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align0:
      type: string
      enum:
        - start
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align1:
      type: string
      enum:
        - middle
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align2:
      type: string
      enum:
        - end
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align2
      description: 'Title alignment: ''start'', ''middle'', or ''end''.'
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name2:
      type: object
      properties:
        text:
          type: string
          description: >-
            Title text. Supports embedded formulas in {{double curly braces}}
            with optional d3 formatting via pipe, e.g. "Total: {{Count() |
            ,.0f}}".
        color:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Color
          description: >-
            Hex color (`#rgb` or `#rrggbb`) or theme color reference `{ kind:
            "theme", ref: "colors-xxx" }`.
        fontWeight:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2FontWeight
          description: 'Title font weight: ''normal'' or ''bold''.'
        fontSize:
          type: number
          format: double
          description: Title font size in pixels.
        align:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0NameOneOf2Align
          description: 'Title alignment: ''start'', ''middle'', or ''end''.'
      required:
        - text
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name2
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name:
      oneOf:
        - type: string
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name1
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name2
      description: >-
        Display name. A bare string for text-only, an object `{ text, ...styling
        }` for font size, color, alignment, or weight, or `{ visibility:
        'hidden' }` to hide the title. Supports embedded {{formula}}
        interpolation in `text`.
      title: CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0Name
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility0:
      type: string
      enum:
        - shown
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility1:
      type: string
      enum:
        - hidden
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility1
      description: >-
        Set to 'hidden' to hide the description while keeping stored text. Omit
        when shown.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Visibility
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1ColorOneOf1Kind:
      type: string
      enum:
        - theme
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1ColorOneOf1Kind
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Color1:
      type: object
      properties:
        kind:
          $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1ColorOneOf1Kind
        ref:
          type: string
      required:
        - kind
        - ref
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Color1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Color:
      oneOf:
        - type: string
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Color1
      description: >-
        Hex color (`#rgb` or `#rrggbb`) or theme color reference `{ kind:
        "theme", ref: "colors-xxx" }`.
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Color
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight0:
      type: string
      enum:
        - normal
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight1:
      type: string
      enum:
        - bold
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight:
      oneOf:
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight0
        - $ref: >-
            #/components/schemas/CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight1
      description: 'Description font weight: ''normal'' or ''bold''.'
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1FontWeight
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Position0:
      type: string
      enum:
        - auto
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Position0
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Position1:
      type: string
      enum:
        - below
      title: >-
        CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Position1
    CreateWorkbookSpecPagesItemsElementsItemsOneOf0OneOf0DescriptionOneOf1Position2:
      type: string
      enum:
        - tooltip
      title: >-
[...]
